﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8
@EndOfDesignText@
Sub Class_Globals
	Private xui As XUI
	Private TextField As B4XFloatTextField
	Private CLV As CustomListView
	Private BBCodeView1 As BBCodeView
	Private Engine As BCTextEngine
	Private bc As BitmapCreator
	Private ArrowWidth As Int = 10
End Sub

Public Sub Initialize (Parent As B4XView)
	Parent.LoadLayout("1")
	Engine.Initialize(Parent)
	bc.Initialize(300, 300)
	TextField.NextField = TextField
End Sub

Private Sub TextField_EnterPressed
	AddItem(TextField.Text, True)
End Sub

Private Sub AddItem (Text As String, Right As Boolean)
	Dim p As B4XView = xui.CreatePanel("")
	BBCodeView1.ExternalRuns = BuildMessage(Text, "User 1")
	BBCodeView1.ParseAndDraw
	Dim ivText As B4XView = CreateImageView
	Dim bmpText As B4XBitmap = GetBitmap(BBCodeView1.ForegroundImageView)
	ivText.SetBitmap(bmpText)
	Dim ivBG As B4XView = CreateImageView
	Dim bmpBG As B4XBitmap = DrawBubble(bmpText.Width, bmpText.Height, Right)
	bc.SetBitmapToImageView(bmpBG, ivBG)
	Dim gap As Int = 6dip
	p.SetLayoutAnimated(0, 0, 0, CLV.AsView.Width, bmpText.Height + 3 * gap)
	p.AddView(ivBG, 0, gap, bmpBG.Width * xui.Scale, bmpBG.Height * xui.Scale)
	p.AddView(ivText, gap + ArrowWidth, 2 * gap, 20dip + bmpText.Width, bmpText.Height)
	CLV.Add(p, Null)
	Sleep(100)
	CLV.ScrollToItem(CLV.Size - 1)
End Sub

Private Sub DrawBubble (Width As Int, Height As Int, Right As Boolean) As B4XBitmap
	Width = Width / xui.Scale
	Height = Height / xui.Scale
	Dim gap As Int = 6
	Dim nw As Int = Width + 3 * gap + ArrowWidth
	Dim nh As Int = Height + 2 * gap
	If bc.mWidth < nw Or bc.mHeight < nh Then
		bc.Initialize(Max(bc.mWidth, nw), Max(bc.mHeight, nh))
	End If
	bc.DrawRect(bc.TargetRect, xui.Color_Transparent, True, 0)
	Dim r As B4XRect
	r.Initialize(ArrowWidth, 1, nw, nh)
	Dim clr As Int = 0xFFC1F7A3
	bc.DrawRectRounded(r, clr, True, 0, 10)
	Dim path As BCPath
	path.Initialize(1, 1)
	path.LineTo(10 + ArrowWidth, 1)
	path.LineTo(ArrowWidth, 10)
	path.LineTo(1, 1)
	bc.DrawPath(path, clr, True, 0)
	bc.DrawPath(path, clr, False, 2)
	Dim b As B4XBitmap = bc.Bitmap
	Return b.Crop(0, 1, nw, nh)
End Sub

Private Sub BuildMessage (Text As String, User As String) As List
	Dim title As BCTextRun = Engine.CreateRun(User & CRLF)
	title.TextFont  = BBCodeView1.ParseData.DefaultBoldFont
	Dim TextRun As BCTextRun = Engine.CreateRun(Text & CRLF)
	Dim time As BCTextRun = Engine.CreateRun(DateTime.Time(DateTime.Now))
	time.TextFont = xui.CreateDefaultFont(10)
	time.TextColor = xui.Color_Gray
	Return Array(title, TextRun, time)
End Sub

Private Sub GetBitmap (iv As ImageView) As B4XBitmap
	#if B4J
	Return iv.GetImage
	#Else If B4A
	Return iv.Bitmap
	#End If
End Sub

Private Sub CreateImageView As B4XView
	Dim iv As ImageView
	iv.Initialize("")
	Return iv
End Sub